/*
	PortForwarder - that do port forwarding and reverse connection.
    Copyright (C) 2007  Shin Ryu(kurishin@naver.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/
package org.codemaru;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.InetSocketAddress;
import java.nio.channels.SocketChannel;

class ListenerThread extends Thread {
	SocketChannel fromSockChannel = null;
	String serviceHost;
	int servicePort;
	
	static Log log = ConsoleLog.getInstance();
	
	public ListenerThread(SocketChannel fromSockChannel, String serviceHost, int servicePort) {
		this.fromSockChannel = fromSockChannel;
		this.serviceHost = serviceHost;
		this.servicePort = servicePort;
	}
	
	public void run() {
		ConfigFactory conf = ConfigFactory.getInstance();
		SocketChannel socketChannel;
		SocketChannel serviceSockChannel;
		String id;
		
		for (;;) {
			try {
				BufferedReader br = new BufferedReader(new InputStreamReader(fromSockChannel.socket().getInputStream()));			
			
				log.debug("waiting readLine(id)...");
				id = br.readLine();
				
				if (id == null) {
					log.debug("id is null ");
					try {
						sleep(1000);
					} catch (InterruptedException ignored) {
					}
					return;
				}
				
				if (id.length() == 0) {
					log.debug("received alive packet");
					continue;
				}
				
				log.debug("id = " + id);
			
				socketChannel = SocketChannel.open();				
				socketChannel.connect(new InetSocketAddress(conf.getServerHost(), conf.getServerPort()));
				socketChannel.socket().getOutputStream().write(("C\n" + id + "\n").getBytes());
				socketChannel.socket().getOutputStream().flush();
				
				serviceSockChannel = SocketChannel.open();
				serviceSockChannel.connect(new InetSocketAddress(serviceHost, servicePort));
				ComThread thread = new ComThread(serviceSockChannel, socketChannel);
				thread.start();
			} catch (IOException e) {
				/*
				try {
					sleep(10000);
				} catch (InterruptedException ignored) {
				}
				*/
				log.info(e.getMessage());
				return;
			}
		}
	}
}
