/*
	PortForwarder - that do port forwarding and reverse connection.
    Copyright (C) 2007  Shin Ryu(kurishin@naver.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/
package org.codemaru;

import java.io.IOException;
import java.net.InetSocketAddress;
import java.net.SocketAddress;
import java.nio.channels.SocketChannel;

import org.codemaru.util.StreamUtil;

public class PClient {
	static Log log = ConsoleLog.getInstance();
	public static void main(String[] args) {
//		SocketChannel fromSockChannel = null;
		SocketChannel toSockChannel = null;
		ConfigFactory conf = ConfigFactory.getInstance();
//		SocketAddress fromAddr;
		SocketAddress toAddr;
		String ret;
		
		System.out.print("PortForwarder Client ver ");
		System.out.println(ConfigFactory.getVersion());
		System.out.println(ConfigFactory.getAuthor());
		System.out.println();

		for (int i=0; i<conf.getPortCount(); i++) {
			try {
//				fromAddr = new InetSocketAddress(conf.getServiceHost(i), conf.getServicePort(i));
				toAddr = new InetSocketAddress(conf.getServerHost(), conf.getServerPort());
				log.info("service.server.host: " + conf.getServiceHost(i));
				log.info("service.server.port: " + conf.getServicePort(i));
				log.info("server.host: " + conf.getServerHost());
				log.info("server.port: " + conf.getServerPort());
				log.info("forwarding.port: " + conf.getForwardingPort(i));
//				fromSockChannel = SocketChannel.open();
				toSockChannel = SocketChannel.open();
//				fromSockChannel.connect(fromAddr);
				toSockChannel.connect(toAddr);

				toSockChannel.socket().getOutputStream().write(("N\n" + conf.getForwardingPort(i) + "\n").getBytes());
				
				ret = StreamUtil.readLine(toSockChannel.socket());

				if (!"OK".equals(ret)) {
					log.fatal("Port already in use");
					continue;
				}
				
				ListenerThread thread = new ListenerThread(toSockChannel, conf.getServiceHost(i), conf.getServicePort(i));
				thread.start();
			} catch (IOException e) {
				e.printStackTrace();
//				log.error(e);
				continue;
			}			
		}
	}
}
