/*
	PortForwarder - that do port forwarding and reverse connection.
    Copyright (C) 2007  Shin Ryu(kurishin@naver.com)

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>
*/
package org.codemaru;

import java.io.IOException;
import java.net.BindException;
import java.net.InetSocketAddress;
import java.nio.channels.SelectionKey;
import java.nio.channels.Selector;
import java.nio.channels.ServerSocketChannel;
import java.nio.channels.SocketChannel;
import java.util.Hashtable;
import java.util.Iterator;

import org.codemaru.util.StreamUtil;

public class PServer {
	public static Hashtable socketChannel = new Hashtable();
	static Log log = ConsoleLog.getInstance();
	public static void main(String[] args) {
		ConfigFactory conf = ConfigFactory.getInstance();
		int port = conf.getServerPort();

		ServerSocketChannel sSockChannel = null;
		Selector selector = null;
		Iterator iter;

		System.out.print("PortForwarder Server ver ");
		System.out.println(ConfigFactory.getVersion());
		System.out.println(ConfigFactory.getAuthor());
		System.out.println();
		
		try {			
			sSockChannel = ServerSocketChannel.open();
			sSockChannel.configureBlocking(false);
			sSockChannel.socket().bind(new InetSocketAddress(port));
			selector = Selector.open();

			sSockChannel.register(selector, SelectionKey.OP_ACCEPT);
			log.info("Listening port: " + port);
		} catch (BindException e) {
			log.fatal("Address already in use");
			return;
		} catch (IOException e) {
//			e.printStackTrace();
//			log.error(e);
			return;
		}
		
		SocketChannel socket;
		byte flag[] = new byte[2];
		
		for (;;) {
			try {
				log.debug("Waiting...");
				selector.select();
				
				iter = selector.selectedKeys().iterator();
				
				while(iter.hasNext())
			    {
			    	SelectionKey key = (SelectionKey)iter.next();			    	
			     
			    	if(key.isAcceptable())
			    	{
			    		socket = ((ServerSocketChannel)key.channel()).accept();
			    		
			    		log.info("Connected from " + socket.socket().toString());
			    		
			    		socket.socket().getInputStream().read(flag);			    		
			    		
			    		log.debug("flag[" + (char)flag[0] + "]");
			    		if (flag[0] == 'N') {
							ForwardThread thread = new ForwardThread(socket);
							thread.start();
			    		}
			    		else if (flag[0] == 'C') {			    			
			    			try {
				    			SocketChannel sc;
				    			
				    			Long id = new Long(StreamUtil.readLine(socket.socket()));
				    			sc = (SocketChannel)socketChannel.get(id);

				    			if (sc == null) {
				    				log.error("id is null");
				    				socket.close();
				    				continue;
				    			}
				    			
				    			log.debug("Connected from PClient, ID=" + id);
				    			
				    			ComThread thread = new ComThread(socket, sc);
				    			thread.start();
			    			}
			    			catch (Exception e) {
			    				e.printStackTrace();
			    				socket.close();
			    			}
			    		}
			    	}
			     
			    	iter.remove();
			    }
			} catch (IOException e) {
				e.printStackTrace();
//				log.error(e);
			}
             
		}
	}
}
