package org.codemaru.util;

import java.io.FileInputStream;
import java.io.IOException;
import java.util.Properties;

/**
 * @author Shin Ryu
 *
 */
public class Config {
	final static String PROPERTIES_FILE = "PortForwarder.properties";	
	private Config() {}
	
	public static String getString(final String key) {
		return getString(PROPERTIES_FILE, key);
	}
	
	public static String getSystemProperty(final String key) {
		Properties p = new Properties(System.getProperties());

		return p.getProperty(key);
	}
	
	public static String getString(final String propertiesFile, final String key) {
		Properties properties = new Properties();
		
	    try {
	        properties.load(new FileInputStream(propertiesFile));
	    } catch (IOException e) {
	    	//e.printStackTrace();
	    }
		
		return properties.getProperty(key);		
	}
	
	public static int getInt(final String key) {
		return getInt(PROPERTIES_FILE, key);
	}
	
	public static int getInt(final String propertiesFile, final String key) {
		String property = getString(propertiesFile, key);
		
		if (property == null)
			return 0;
		
		return Integer.parseInt(property);		
	}
}
