package org.codemaru.util;


/**
 * String utilities
 * 
 * @author Shin Ryu
 * @version     %I%, %G%
 * @
 * @see DateUtil
 */
public final class StringUtil {
	/**
	 * @param s
	 * @return
	 */
	public static String nvl(final String s) {
		return nvl(s, "");
	}
		
	/**
	 * @param s1
	 * @param s2
	 * @return
	 */
	public static String nvl(final String s1, final String s2) {
		return s1 == null ? s2 : s1;
	}
	
	/**
	 * @param s
	 * @param i
	 * @return
	 */
	public static int nvl(final String s, int i) {
		return s == null ? i : Integer.parseInt(getDigitOnly(s));
	}
	
	/**
	 * @param s
	 * @return
	 */
	public static String getDigitOnly(final String s) {
		if (s == null)
			return "";
		
		String strRet = "";
		int len = s.length();
		
		for (int i=0; i<len ; i++) {
			if (Character.isDigit(s.charAt(i)))
				strRet += s.charAt(i);
		}
		
		return strRet;
	}
	
	public static String[] split(final String s, final String d) {
		if (s == null)
			return null;
		
		String del = d; 

//		if ("^.|[]()*+?\\".contains(d))
		
		String reserved = "^.|[]()*+?\\"; 
		for (int i=0; i<reserved.length(); i++) {
			if (reserved.indexOf(d) != -1) {
				del = "\\" + del;
				break;
			}
		}
		
		return s.split(del);
	}
	
	public static String arrayToString(final String[] array) {
		return arrayToString(array, 0);
	}
	
	public static String arrayToString(final String[] array, int index) {		
		StringBuffer sb = new StringBuffer();
		
		for (int i=index; i<array.length; i++)
			sb.append(array[i]);
		return sb.toString();
	}
	
	public static String getToken(String str, int index) {
		return getToken(str, index, ",");
	}

	public static String getToken(String str, int index, String separator) {
		int di = 0;
		int ei = 0;
		
		if (str == null)
			return null;
		
		for (int i=0; i<=index; i++) {
			if (i == 0)
				di = 0;
			else {
				di = str.indexOf(separator, di);			
				if (di < 0)
					return null;
				di++;
			}
			ei = str.indexOf(separator, di);
			if (ei == -1)
				ei = str.length();
		}
		return str.substring(di, ei);
	}
}
